/*
 *  Copyright (C) 2014-2015 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2014-2015 by FUJI SOFT INCORPORATED, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥  
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: CddBodyControl.c 122 2015-07-17 01:31:28Z ertl-honda $
 */  

/*
 *  CDD SW-C CddBodyControlѤε
 */

#include "Rte_CddBodyControl.h"
#include "ModelCarControl.h"
#include "t_syslog.h"

/*
 *  CDD SW-C CddBodyControlѤν
 */
void
CddBodyControlInit(void)
{
	tInitBody();
}

/*
 *  LampControlʥ֥
 */
void
LampControl(void)
{
	Std_ReturnType	ercd;
	IDT_Lamp		headlamp;
	IDT_Lamp		foglamp;
	IDT_Lamp		brakelamp;
	IDT_Lamp		backlamp;

	/* LampInּ */
	ercd = Rte_Read_LampIn_headlamp(&headlamp);
	ercd += Rte_Read_LampIn_foglamp(&foglamp);
	ercd += Rte_Read_LampIn_brakelamp(&brakelamp);
	ercd += Rte_Read_LampIn_backlamp(&backlamp);

	/* 1ĤǤ˼Ԥ³νϼ¹Ԥʤ */
	if (ercd != RTE_E_OK) {
		syslog(LOG_INFO, "## Error: Rte_Read_LampIn()");
	}
	else {
		HEAD_LAMP_SET(headlamp);
		FOG_LAMP_SET(foglamp);
		BRAKE_LAMP_SET(brakelamp);
		BACK_LAMP_SET(backlamp);
	}
}

/*
 *  󥫡Ǽѥ󥿤ν
 */
#define CNT_BLINK_INIT  (WINKER_INTERVAL_MS/BODY_CYCLE_MS)

/*
 *  WinkerControlʥ֥
 */
void
WinkerControl(void)
{
	Std_ReturnType		ercd;
	IDT_Winker			winker;
	static IDT_Winker	pre_winker = 0U;
	static boolean		pre_winker_lr = FALSE;
	static boolean		pre_winker_l = FALSE;
	static boolean		pre_winker_r = FALSE;
	static uint8		cnt_blink = 0U;

	/* Winkerǡ */
	ercd = Rte_Read_WinkerIn_state(&winker);
	if (ercd != RTE_E_OK) {
		syslog(LOG_INFO, "## Error: Rte_Read_WinkerIn_state()");
		return;
	}

	/* ؼѲäߥ󥰤Ǽ򳫻Ϥ */
	if (winker != pre_winker) {
		cnt_blink = 0U;
	}

	if (cnt_blink == 0U) {
		switch (winker) {
		case WINKER_OFF: /*  */
			WINKER_L_SET(FALSE);
			WINKER_R_SET(FALSE);
			break;
		case WINKER_L_ON: /* Τ */
			WINKER_L_SET(TRUE);
			break;
		case WINKER_R_ON: /* Τ */
			WINKER_R_SET(TRUE);
			break;
		case WINKER_LR_ON: /*  */
			WINKER_L_SET(TRUE);
			WINKER_R_SET(TRUE);
			break;
		case WINKER_L_BLINK: /* Τ */
			if (pre_winker_l == FALSE) {
				WINKER_L_SET(TRUE);
				pre_winker_l = TRUE;
			}
			else {
				WINKER_L_SET(FALSE);
				pre_winker_l = FALSE;
			}
			break;
		case WINKER_R_BLINK: /* Τ */
			if (pre_winker_r == FALSE) {
				WINKER_R_SET(TRUE);
				pre_winker_r = TRUE;
			}
			else {
				WINKER_R_SET(FALSE);
				pre_winker_r = FALSE;
			}
			break;
		case WINKER_LR_BLINK: /*  */
			if (pre_winker_lr == FALSE) {
				WINKER_L_SET(TRUE);
				WINKER_R_SET(TRUE);
				pre_winker_lr = TRUE;
			}
			else {
				WINKER_L_SET(FALSE);
				WINKER_R_SET(FALSE);
				pre_winker_lr = FALSE;
			}
			break;
		default:
			break;
		}
		cnt_blink = CNT_BLINK_INIT;
	}

	cnt_blink--;

	pre_winker = winker;
}

/*
 *  BuzzerControlʥ֥
 */
void
BuzzerControl(void)
{
	Std_ReturnType	ercd;
	IDT_Buzzer		buzzer;
	static boolean	buzzer_toggle = FALSE;
	static uint16	buzzer_cycle = 0U;
	boolean 		buzzer_on = FALSE;

	/* Buzzerǡ */
	ercd = Rte_Read_BuzzerIn_state(&buzzer);

	if (ercd != RTE_E_OK) {
		syslog(LOG_INFO, "## Error: Rte_Read_BuzzerIn_state()");
		return;
	}

	switch (buzzer) {
	  case BUZZER_OFF:
		/* ò */
		break;
	  case BUZZER_ON:
		/* ȯ */
		buzzer_on = TRUE;
		break;
	  case BUZZER_INTERVAL_ON:
		/* ֳ֤ȯ */
		buzzer_cycle++;
		if (buzzer_cycle < ((BUZZER_INTERVAL_MS * 1000)/BUZZER_CYCLE_NS)) {
			buzzer_on = TRUE;
		}
		if (buzzer_cycle == ((BUZZER_INTERVAL_MS * 1000)/BUZZER_CYCLE_NS)*2) {
			buzzer_cycle = 0U;
		}
		break;
	  default:
		break;
	}

	if (buzzer_on == TRUE) {
		tSetBuzzer(buzzer_toggle);
		buzzer_toggle = (buzzer_toggle == TRUE) ? FALSE : TRUE;
	} else {
		tSetBuzzer(FALSE);
	}
}
